//
//	NAME:	EXTRA MAME v.1.5
//	AUTHOR: RUSLAN SMEKALOV
//	SITE:	WWW.GODLIKEDEVELOPERS.COM
//	E-MAIL:	CONTACTS@WINTOOLS.NET
//

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <stdio.h>
#include <direct.h>
#include <fcntl.h>
#include <shellapi.h>
#include <io.h>
#include "Splash.h"
#include "Dib.h"
#include "buttonex.h"
#include "coolmenu.h"
#include "extramameres.h"
/*<---------------------------------------------------------------------->*/

// Place wlib.lib in the LCCROOT\lcc\lib folder
#pragma lib <wlib.lib>

HWND hwndLVGlob;
int iGlobLVSort=0;

HMENU hvMenu="";
HINSTANCE hInst;
HWND hwndMain;
HWND  hWndStatusbar;

LV_ITEM lvIT;
LV_ITEM lvIA;
LV_ITEM lvIAA;

int iSizeWindow=0;
int xRaznica=0;
int yRaznica=0;

HFONT f_smalltiny;
HFONT f_smallbold;

char work_path[MAX_PATH]="";
char ini_path[MAX_PATH]="";
char lng_path[MAX_PATH]="";
char gamelist_path[MAX_PATH]="";
char roms_path[MAX_PATH]="";
char mame_path[MAX_PATH]="";
char png2bmp_path[MAX_PATH]="";
char mgbmp_path[MAX_PATH]="";
char wini_path[MAX_PATH]="";
char defbmp_path[MAX_PATH]="";
char help_path[MAX_PATH]="";

void CreateWindows4MAME(void);
void CreateWindows4_MAME(void);
void Fill_LV_AllGames(void);
void Switch_TAB(void);
void Fill_LV_AvailableGames(void);
int ListView_FindGame(char *full_name);
void Fill_LV_EditBox(char *ch_path, int i_Item, HWND hWnD);
void SetGameBmp(char *chGame);
void UpdateStatusBarLV(void);
void Fill_Game_Info(void);
void FillCommandLine(void);
void ApplyCommandLine(void);
void AddCommandLineOptions(char *t_path);
void Create_Menu(void);
void Switch_List(void);

LRESULT CALLBACK WT_DLGADVICE(HWND hwndADVICE,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

int CALLBACK CompareFunc(int iItemFirst, int iItemSecond, LPARAM lParamSort){
	char cmpstr1[MAX_PATH];
	char cmpstr2[MAX_PATH];
	ListView_GetItemText(hwndLVGlob,iItemFirst,iGlobLVSort,cmpstr1,200);
	ListView_GetItemText(hwndLVGlob,iItemSecond,iGlobLVSort,cmpstr2,200);

	if(lParamSort == 1)return stricmp((char*)cmpstr1, (char*)cmpstr2);
    else return -stricmp((char*)cmpstr1, (char*)cmpstr2);
	}

char* GetLangName(char *iName){
	static char chGlobName[1024]="unnamed";

	GetPrivateProfileString("INTERFACE",iName,NULL,chGlobName,1024, lng_path);

	for(int i=0; i<strlen(chGlobName); i++){
		if(chGlobName[i]=='~')chGlobName[i]='\n';
		}

	return chGlobName;
	}

void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags){
    SendMessage(hWndStatusbar,SB_SETTEXT,partNumber | displayFlags,(LPARAM)lpszStatusString);
	}

LRESULT MsgMenuSelect(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam){

    static char szBuffer[256];
    UINT   nStringID = 0;
    UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
    UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
    HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

    szBuffer[0] = 0;
    if (fuFlags == 0xffff && hMenu == NULL)
        nStringID = 0;

    else if (fuFlags & MFT_SEPARATOR)
        nStringID = 0;

    else if (fuFlags & MF_POPUP)
    {
        if (fuFlags & MF_SYSMENU)
            nStringID = IDS_SYSMENU;
        else

            nStringID = 0;
    }
    else
        nStringID = uCmd;


	char chRes[MAX_PATH];
    if (0 != nStringID){

	UpdateStatusBar(GetLangName(itoa(nStringID,chRes,10)), 0, 0);
	}else{
		Switch_List();
		}
    return 0;
}

void InitializeStatusBar(HWND hwndParent,int nrOfParts){

    int   ptArray[40];
    RECT  rect;
    HDC   hDC;

   /* * Fill in the ptArray...  */

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right;



	ptArray[0] = 200;
    ptArray[1] = 400;
    ptArray[2] = 600;
    ptArray[3] = 800;


    ReleaseDC(hwndParent, hDC);
    SendMessage(hWndStatusbar,SB_SETPARTS,nrOfParts,(LPARAM)(LPINT)ptArray);









	}

static BOOL CreateSBar(HWND hwndParent,char *initialText,int nrOfParts){
    hWndStatusbar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,initialText,hwndParent,IDM_STATUSBAR);
    if(hWndStatusbar){
        InitializeStatusBar(hwndParent,nrOfParts);
        return TRUE;
    	}
    return FALSE;
	}

static BOOL InitApplication(void)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW |CS_DBLCLKS ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
	wc.lpszClassName = "winshell4mameWndClass";

	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(ICO_ALLGAMES));
	if (!RegisterClass(&wc))return 0;

	return 1;
	}

BOOL WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, INT iString, LPCTSTR lpFileName){
	char lpString[10+2]="";
	itoa(iString,lpString,10);
	return WritePrivateProfileString(lpAppName,lpKeyName,lpString,lpFileName);
	}

HWND Createwinshell4mameWndClassWnd(void){
	return CreateWindow("winshell4mameWndClass","Extra M.A.M.E.",

		WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_CLIPSIBLINGS|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_THICKFRAME,
		CW_USEDEFAULT,0,800,530,
		NULL,
		NULL,
		hInst,
		NULL);
	}

void OptionsCheckMenu(UINT uID,char *szItem){

	if(GetPrivateProfileInt("OPTIONS",szItem,0,ini_path)){
		CheckMenuItem(hvMenu,uID,MFS_UNCHECKED);
		WritePrivateProfileString("OPTIONS",szItem,"0",ini_path);
		}else{
			CheckMenuItem(hvMenu,uID,MFS_CHECKED);
			WritePrivateProfileString("OPTIONS",szItem,"18",ini_path);
			}
	}

void OptionsAlwaysOnTop(void){
	if(!GetPrivateProfileInt("OPTIONS","Ontop",0,ini_path)){
		SetWindowPos(hwndMain, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE	| SWP_NOSIZE);
		}else{
			SetWindowPos(hwndMain, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE	| SWP_NOSIZE);
			}
	}

BOOL WinRunShell(char *path, char *param, char *lpVerb){
	SHELLEXECUTEINFO ShExecInfo = {0};
	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = SEE_MASK_NOCLOSEPROCESS|SEE_MASK_INVOKEIDLIST;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = lpVerb;
	ShExecInfo.lpFile = path;
	ShExecInfo.lpParameters = param;
	ShExecInfo.lpDirectory = NULL;
	ShExecInfo.nShow = SW_SHOW;
	ShExecInfo.hInstApp = NULL;
	return ShellExecuteEx(&ShExecInfo);
	}

BOOL MagnetWindow(LPARAM *lParam){
	RECT *pRect = (LPRECT) *lParam;
	static RECT rcOld = { 0, 0, 0, 0 };
	RECT rcDesktop;
	INT	 iPower = 20;
	SIZE szSize;


	if(FALSE == SystemParametersInfo(SPI_GETWORKAREA, 0, &rcDesktop, 0))
		return FALSE;

	szSize.cx = pRect->right -  pRect->left;
	szSize.cy = pRect->bottom - pRect->top;


	if(pRect->top < iPower && rcOld.top > pRect->top)
	{
		pRect->top = 0;
		pRect->bottom = szSize.cy;
	}
	else
	if(pRect->bottom > (rcDesktop.bottom - iPower) &&
	   rcOld.bottom  < pRect->bottom)
	{
		pRect->bottom = rcDesktop.bottom;
		pRect->top = rcDesktop.bottom - szSize.cy;
	}

	if(pRect->left < iPower && rcOld.left > pRect->left)
	{
		pRect->left = 0;
		pRect->right = szSize.cx;
	}
	else
	if(pRect->right > (rcDesktop.right - iPower) &&
		rcOld.right < pRect-> right)
	{
		pRect->right = rcDesktop.right;
		pRect->left =  rcDesktop.right - szSize.cx;
	}

	rcOld.top = pRect -> top;
	rcOld.bottom = pRect -> bottom;
	rcOld.left = pRect -> left;
	rcOld.right = pRect -> right;

	return TRUE;
	}

void MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	switch(id) {

		case ID_GETGAME:{
			char chLink[MAX_PATH]="http://www.google.com/search?q=";
			char t_path[MAX_PATH]="";
			int i=ListView_GetNextItem(GetDlgItem(hwndMain,ID_MAMELV),-1,LVNI_FOCUSED|LVNI_SELECTED);
			ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,6,t_path,MAX_PATH);

			char ch[MAX_PATH]="";
			strcpy(ch,t_path+1);
			ch[(strchr(ch,' ')-ch)]='\0';
			strcpy(t_path,ch);

			strcat(chLink,t_path);
			strcat(chLink,".zip+rom+mame+download");
			ShellExecute(hwndMain,"open",chLink,"","", SW_SHOW );
			}break;

		case ID_GETBIOS:{
			ShellExecute(hwndMain,"open","http://www.google.com/search?q=neogeo.zip+decocass.zip+mame+download","","", SW_SHOW );
			}break;

		case ID_ABOUT:{
			char win_path[MAX_PATH]="";
			strcpy(win_path,work_path);
			strcat(win_path,"\\docs\\extra-eng.txt");
			WinRunShell("notepad.exe",win_path,NULL);
			}break;

		case ID_GAMELIST:
		case IDM_HELP:{
			WinRunShell("notepad.exe",gamelist_path,NULL);
			}break;

		case IDM_LICENSE:{
			char win_path[MAX_PATH]="";
			strcpy(win_path,work_path);
			strcat(win_path,"\\docs\\windows.txt");
			WinRunShell("notepad.exe",win_path,NULL);
			}break;

		case ID_WEBSITE:
		case IDM_WEB:{
			ShellExecute(hwndMain,"open","http://www.godlikedevelopers.com/","","", SW_SHOW );
			}break;

		case ID_SUPPORT:
		case IDM_EMAIL:{
			ShellExecute(hwndMain,"open","mailto:support@wintools.net","","", SW_SHOW );
			}break;

		case IDM_DOWNLOAD:{
			ShellExecute(hwndMain,"open","http://www.godlikedevelopers.com/","","", SW_SHOW );
			}break;

		case IDM_ABOUT:{
			MessageBox(hwndMain,"Extra M.A.M.E. Version 1.5\nFebruary 15, 2005\n\nAuthor: Ruslan Smekalov\nhttp://www.godlikedevelopers.com/","About Extra M.A.M.E.",MB_OK|MB_ICONINFORMATION);
			}break;


		case ID_LANG_MENU:{
			chdir(work_path);
			WinExec("language.exe",SW_SHOW);
			}break;


		case ID_ONTOP_MENU:{
			OptionsCheckMenu(ID_ONTOP_MENU,"Ontop");
			OptionsAlwaysOnTop();
			}break;


		case ID_MAGNET_MENU:{
			OptionsCheckMenu(ID_MAGNET_MENU,"Magnet");
			}break;


		case ID_POSITION_MENU:{
			OptionsCheckMenu(ID_POSITION_MENU,"Position");
			}break;


		case ID_SIZE_MENU:{
			OptionsCheckMenu(ID_SIZE_MENU,"Size");
			}break;

		case ID_COMMAND:{
			chdir(work_path);
			WinRunShell("command.com",NULL,NULL);
			}break;


		case ID_NEW_MENU:{
			WinRunShell("notepad.exe",NULL,NULL);
			}break;


		case ID_OPEN_MENU:{
			char File[MAX_PATH] = {0};
			OPENFILENAME ofn;
			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize 	= sizeof(OPENFILENAME);
			ofn.hInstance   	= hInst;
			ofn.Flags			= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_ENABLEHOOK;
			ofn.hwndOwner		= hwndMain;
			ofn.lpstrFilter		= "All Files (*.*)\0*.*\0""EXE Files (*.EXE)\0*.exe\0""COM Files (*.COM)\0*.com\0\0";
			ofn.lpstrTitle		= GetLangName("5");
			ofn.lpstrInitialDir = "c:\\";
			ofn.lpstrFile		= File;
			ofn.nMaxFile		= MAX_PATH;
			ofn.lpstrCustomFilter = NULL;
			ofn.nMaxCustFilter	= 0L;
			ofn.lpfnHook		= 0;
			GetOpenFileName(&ofn);
			if(File[0])WinRunShell("notepad.exe",File,NULL);
			}break;

		case ID_BUTAPPLY:{
			ApplyCommandLine();
			}break;

		case ID_BUTPLAY:{
			char t_path[1500]="";
			int i=ListView_GetNextItem(GetDlgItem(hwndMain,ID_MAMELVA),-1,LVNI_FOCUSED|LVNI_SELECTED);
			ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELVA),i,6,t_path,MAX_PATH);

			char chTemp[MAX_PATH]="";
			strcpy(chTemp,wini_path);
			strcat(chTemp,t_path);
			strcat(chTemp,".ini");
			SetWindowText(hwndMain,chTemp);
			int x=GetPrivateProfileInt("OPTIONS","Runs",0,chTemp);
			x++;
			WritePrivateProfileInt("OPTIONS","Runs",x,chTemp);
			itoa(x,chTemp,10);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),i,1,chTemp);

			AddCommandLineOptions(t_path);
			ShellExecute(hwndMain,"open",mame_path,t_path,work_path, SW_SHOW);
			}break;

		case ID_BUTREFRESH:{

			EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),FALSE);
			EnableWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),FALSE);
			EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),FALSE);

			Fill_LV_AllGames();
			Fill_LV_AvailableGames();

			EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),TRUE);
			EnableWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),TRUE);
			EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),TRUE);

			switch(TabCtrl_GetCurSel(GetDlgItem(hwndMain,ID_MAMETAB))){
				case 0:{
					int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
					i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),1);
					}break;
				case 2:{
					int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVAA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
					}break;
				}

			UpdateStatusBarLV();
			}break;

		case ID_BUTDELETE:{

			char del_path[MAX_PATH]="";;
			char t_path[MAX_PATH]="";;
			char chTempLang1[MAX_PATH];strcpy(chTempLang1,GetLangName("10"));
			char chTempLang2[MAX_PATH];strcpy(chTempLang2,GetLangName("11"));

			switch(TabCtrl_GetCurSel(GetDlgItem(hwndMain,ID_MAMETAB))){
				case 0:{

					int i=ListView_GetNextItem(GetDlgItem(hwndMain,ID_MAMELVA),-1,LVNI_FOCUSED|LVNI_SELECTED);
					if(i==-1)i=0;
					ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELVA),i,6,t_path,MAX_PATH);
					strcat(t_path,".zip");

					strcat(chTempLang2,t_path);
					strcat(chTempLang2,GetLangName("12"));
					if(IDYES!=MessageBox(hwndMain,chTempLang2,chTempLang1,MB_YESNO|MB_ICONQUESTION))break;

					strcpy(del_path,roms_path);
					strcat(del_path,t_path);

					ListView_DeleteItem(GetDlgItem(hwndMain,ID_MAMELVA),i);

					SHFILEOPSTRUCT SHF;
					memset(&SHF, 0, sizeof(SHFILEOPSTRUCT));
					int l = strlen(del_path);
					del_path[l+1] = 0;
					SHF.hwnd = NULL;
					SHF.wFunc = FO_DELETE;
					SHF.pFrom = del_path;
					SHF.fFlags = FOF_SILENT | FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI;
					SHFileOperation(&SHF);
					UpdateStatusBarLV();

					i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
					i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),1);
					}break;
				case 2:{

					int i=ListView_GetNextItem(GetDlgItem(hwndMain,ID_MAMELVAA),-1,LVNI_FOCUSED|LVNI_SELECTED);
					if(i==-1)i=0;
					ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELVAA),i,1,t_path,MAX_PATH);
					ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELVAA),i,2,del_path,MAX_PATH);

					strcat(chTempLang2,t_path);
					strcat(chTempLang2,GetLangName("12"));
					if(IDYES!=MessageBox(hwndMain,chTempLang2,chTempLang1,MB_YESNO|MB_ICONQUESTION))break;

					ListView_DeleteItem(GetDlgItem(hwndMain,ID_MAMELVAA),i);
					SHFILEOPSTRUCT SHF;
					memset(&SHF, 0, sizeof(SHFILEOPSTRUCT));
					int l = strlen(del_path);
					del_path[l+1] = 0;
					SHF.hwnd = NULL;
					SHF.wFunc = FO_DELETE;
					SHF.pFrom = del_path;
					SHF.fFlags = FOF_SILENT | FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI;
					SHFileOperation(&SHF);
					UpdateStatusBarLV();
					i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVAA));
					if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
					}break;
				}

			}break;

		case IDM_EXIT:
		PostMessage(hwnd,WM_CLOSE,0,0);
		break;
	}
}

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch (msg) {

	case WM_MOVING:{
		if(GetPrivateProfileInt("OPTIONS","Magnet",0,ini_path)){
			return MagnetWindow(&lParam);
			}
		return TRUE;
		}break;

	case WM_CONTEXTMENU :
		CoolMenu_PopupContext(hwnd, lParam, 1);
		return 0;

	case WM_MEASUREITEM :
		return CoolMenu_MeasureItem(wParam, lParam);

	case WM_DRAWITEM :
		return CoolMenu_DrawItem(wParam, lParam);


	case WM_GETMINMAXINFO:{
		MINMAXINFO * r = (MINMAXINFO*)lParam;
		r->ptMinTrackSize.x = 800;
		r->ptMinTrackSize.y = (530+iSizeWindow);
		return 0;
		}break;


	case WM_SIZE:{

		RECT winRect;
		GetWindowRect(hwndMain,&winRect);
		xRaznica=(winRect.right-winRect.left)-800;
		yRaznica=(winRect.bottom-winRect.top)-(530+iSizeWindow);
		{
			int xRaznica2=xRaznica/2;

			int yRaznica2=yRaznica/2;


			MoveWindow(GetDlgItem(hwndMain,BMP_0),10,10,773+xRaznica,60,TRUE);

			MoveWindow(GetDlgItem(hwndMain,BMP_2),482,11,100+xRaznica,58,TRUE);
			MoveWindow(GetDlgItem(hwndMain,BMP_3),582+xRaznica,11,200,58,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_BMP),567+xRaznica2,100,202+xRaznica2,200+yRaznica,TRUE);
			SendMessage(GetDlgItem(hwndMain,ID_BMP),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadImage(hInst,mgbmp_path,IMAGE_BITMAP,202+xRaznica/2,200+yRaznica,LR_LOADFROMFILE));


			MoveWindow(GetDlgItem(hwndMain,ID_GROUPMAME),554+xRaznica2,80,228+xRaznica2,324+yRaznica,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),38,123,473+xRaznica2,290+yRaznica,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_EDIT5),52,150,444+xRaznica2,22,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),25,115,500+xRaznica2,311+yRaznica,TRUE);
			MoveWindow(GetDlgItem(hwndMain,1),10,10,775+xRaznica,60,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_MAMELV),25,115,500+xRaznica2,311+yRaznica,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_MAMELVA),25,115,500+xRaznica2,311+yRaznica,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_MAMELVAA),25,115,500+xRaznica2,311+yRaznica,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_EDIT1),25,115,500+xRaznica2,311+yRaznica,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_EDIT2),25,115,500+xRaznica2,150+yRaznica2,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_EDIT3),25,276+yRaznica2,500+xRaznica2,150+yRaznica2,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_BUTPLAY),553+xRaznica2,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),631+xRaznica2+xRaznica2/3,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_BUTDELETE),709+xRaznica2+(xRaznica2/3*2),415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),426+xRaznica2-xRaznica2/3,374+yRaznica,73+xRaznica2/3,28,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_GETBIOS),553+xRaznica2,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_GETGAME),553+xRaznica2,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_GAMELIST),709+xRaznica2+(xRaznica2/3*2),415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_WEBSITE),553+xRaznica2,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_SUPPORT),631+xRaznica2+xRaznica2/3,415+yRaznica,73+xRaznica2/3,28,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_ABOUT),709+xRaznica2+(xRaznica2/3*2),415+yRaznica,73+xRaznica2/3,28,TRUE);

			MoveWindow(GetDlgItem(hwndMain,ID_EDIT4),567+xRaznica2,315+yRaznica,203+xRaznica2,76,TRUE);
			MoveWindow(GetDlgItem(hwndMain,ID_MAMETAB),10,80,533+xRaznica2,363+yRaznica,TRUE);

		}
		SendMessage(hWndStatusbar,msg,wParam,lParam);
		InitializeStatusBar(hWndStatusbar,5);
		}break;

	case WM_NOTIFY:{
		NMITEMACTIVATE * lpnmia = (NMITEMACTIVATE*)lParam;
		NM_LISTVIEW * lpnmch = (NM_LISTVIEW*)lParam;
		LPNMHDR pnmh=(LPNMHDR)lParam;
		switch (pnmh->code){

	        case LVN_KEYDOWN:
				{
				HWND h=GetFocus();
				if(h==GetDlgItem(hwndMain,ID_MAMELVA)||h==GetDlgItem(hwndMain,ID_MAMELV)){

	                LV_KEYDOWN *info = (LV_KEYDOWN *)lParam;
    	            WORD wVKey = info->wVKey;

					char t_path[MAX_PATH]="";
					int i=ListView_GetNextItem(h,-1,LVNI_FOCUSED|LVNI_SELECTED);

					if(wVKey==VK_DOWN)i++;

					if(wVKey==VK_UP)i--;

					if(i<0)i=0;
					int x=ListView_GetItemCount(h)-1;
					if(i>x)i=x;


					char t_path1[MAX_PATH]=" ";
					ListView_GetItemText(h,i,0,t_path,MAX_PATH);
					strcpy(t_path1+1,t_path);


					UpdateStatusBar(t_path1, 0, 0);


					strcpy(t_path1,"\r\n");
					strcat(t_path1,t_path);


					int a=strlen(t_path1)-1;
					while(t_path1[a]==' '){
						a--;
						}
					t_path1[a+1]='\0';


					ListView_GetItemText(h,i,6,t_path,MAX_PATH);


					if(h==GetDlgItem(hwndMain,ID_MAMELV)){
						char ch[MAX_PATH]="";
						strcpy(ch,t_path+1);
						ch[(strchr(ch,' ')-ch)]='\0';
						strcpy(t_path,ch);
						}


					strcat(t_path1,"\r\n\r\n");
					strcat(t_path1,GetLangName("6"));
					strcat(t_path1,t_path);
					SetWindowText(GetDlgItem(hwndMain,ID_EDIT4),t_path1);


					SetGameBmp(t_path);

					}
				}break;

			case NM_CLICK: {
				HWND h=GetFocus();
				if(h==GetDlgItem(hwndMain,ID_MAMELVA)||h==GetDlgItem(hwndMain,ID_MAMELV)){


					char t_path[MAX_PATH]="";
					char t_path1[MAX_PATH]=" ";
					ListView_GetItemText(h,lpnmia->iItem,0,t_path,MAX_PATH);
					strcpy(t_path1+1,t_path);


					UpdateStatusBar(t_path1, 0, 0);


					strcpy(t_path1,"\r\n");
					strcat(t_path1,t_path);


					int a=strlen(t_path1)-1;
					while(t_path1[a]==' '){
						a--;
						}
					t_path1[a+1]='\0';


					ListView_GetItemText(h,lpnmia->iItem,6,t_path,MAX_PATH);

					if(h==GetDlgItem(hwndMain,ID_MAMELV)){
						char ch[MAX_PATH]="";
						strcpy(ch,t_path+1);
						ch[(strchr(ch,' ')-ch)]='\0';
						strcpy(t_path,ch);
						}


					strcat(t_path1,"\r\n\r\n");
					strcat(t_path1,GetLangName("6"));
					strcat(t_path1,t_path);
					SetWindowText(GetDlgItem(hwndMain,ID_EDIT4),t_path1);


					SetGameBmp(t_path);
					}
				}break;

			case LVN_ITEMACTIVATE:{
				if(GetFocus()==GetDlgItem(hwndMain,ID_MAMELVA)){
					char t_path[MAX_PATH];
					ListView_GetItemText(GetFocus(),lpnmia->iItem,6,t_path,MAX_PATH);

					char chTemp[MAX_PATH]="";
					strcpy(chTemp,wini_path);
					strcat(chTemp,t_path);
					strcat(chTemp,".ini");
					SetWindowText(hwndMain,chTemp);
					int x=GetPrivateProfileInt("OPTIONS","Runs",0,chTemp);
					x++;
					WritePrivateProfileInt("OPTIONS","Runs",x,chTemp);
					itoa(x,chTemp,10);
					ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lpnmia->iItem,1,chTemp);

					AddCommandLineOptions(t_path);
					ShellExecute(hwndMain,"open",mame_path,t_path,work_path, SW_SHOW);
					}
			}break;


			case LVN_COLUMNCLICK:{
				static int iParamSort=1;
				hwndLVGlob=pnmh->hwndFrom;
				iGlobLVSort=lpnmch->iSubItem;
				ListView_SortItemsEx(hwndLVGlob, CompareFunc, iParamSort);
				iParamSort=iParamSort?0:1;
				}break;


			case TCN_SELCHANGE:{

				if((HWND)pnmh->hwndFrom==GetDlgItem(hwndMain,ID_MAMETAB)){
					Switch_TAB();

					Fill_Game_Info();
					}
				}break;
			}
		}break;

	case WM_MENUSELECT:
		return MsgMenuSelect(hwnd,msg,wParam,lParam);
	case WM_COMMAND:
		HANDLE_WM_COMMAND(hwnd,wParam,lParam,MainWndProc_OnCommand);
		break;
	case WM_DESTROY:{

		RECT winRect;
		GetWindowRect(hwndMain,&winRect);
		char chWPPS[20]=" ";
		itoa(winRect.left,chWPPS,10);
		WritePrivateProfileString("OPTIONS","Left",chWPPS,ini_path);
		itoa(winRect.top,chWPPS,10);
		WritePrivateProfileString("OPTIONS","Top",chWPPS,ini_path);

		itoa((winRect.right-winRect.left),chWPPS,10);
		WritePrivateProfileString("OPTIONS","Right",chWPPS,ini_path);
		itoa((winRect.bottom-winRect.top)-iSizeWindow,chWPPS,10);
		WritePrivateProfileString("OPTIONS","Bottom",chWPPS,ini_path);

		WINDOWPLACEMENT g_wp;
		g_wp.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(hwndMain, &g_wp);
		if(g_wp.showCmd == SW_SHOWMAXIMIZED){
			WritePrivateProfileString("OPTIONS","ShowMaximized","1",ini_path);
			WritePrivateProfileString("OPTIONS","Right","640",ini_path);
			WritePrivateProfileString("OPTIONS","Bottom","432",ini_path);
			WritePrivateProfileString("OPTIONS","Left","",ini_path);
			WritePrivateProfileString("OPTIONS","Top","",ini_path);
			}else{
				WritePrivateProfileString("OPTIONS","ShowMaximized","0",ini_path);
				}

		CoolMenu_Cleanup(hwnd);

		PostQuitMessage(0);
		}break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	InitCommonControls();

	GetModuleFileName(NULL,work_path,MAX_PATH);
	work_path[(strrchr(work_path,'\\')-work_path)]='\0';


	strcpy(ini_path,work_path);
	strcpy(lng_path,work_path);
	strcpy(help_path,work_path);

	strcat(ini_path,"\\extramame.ini");
	strcat(lng_path,"\\lang\\default.lng");
	strcat(help_path,"\\docs\\");
	GetPrivateProfileString("LANGUAGE","4","extra-eng.txt",gamelist_path,MAX_PATH,lng_path);
	strcat(help_path,gamelist_path);

	strcpy(gamelist_path,work_path);
	strcpy(roms_path,work_path);
	strcpy(mame_path,work_path);
	strcpy(png2bmp_path,work_path);
	strcpy(mgbmp_path,work_path);
	strcpy(wini_path,work_path);
	strcpy(defbmp_path,work_path);


	strcat(gamelist_path,"\\docs\\gamelist.txt");
	strcat(roms_path,"\\roms\\");
	strcat(mame_path,"\\mame.exe");
	strcat(png2bmp_path,"\\snap\\png2bmp.exe");
	strcat(defbmp_path,"\\snap\\defgame.bmp");
	strcat(mgbmp_path,"\\snap\\mamegame.bmp");
	strcat(wini_path,"\\winis\\");



	GetShortPathName(work_path,work_path,MAX_PATH);
	GetShortPathName(ini_path,ini_path,MAX_PATH);
	GetShortPathName(lng_path,lng_path,MAX_PATH);
	GetShortPathName(gamelist_path,gamelist_path,MAX_PATH);
	GetShortPathName(roms_path,roms_path,MAX_PATH);

	GetShortPathName(mame_path,mame_path,MAX_PATH);
	GetShortPathName(png2bmp_path,png2bmp_path,MAX_PATH);
	GetShortPathName(mgbmp_path,mgbmp_path,MAX_PATH);


	MSG msg;
	HANDLE hAccelTable;

	hInst = hInstance;
	if (!InitApplication())return 0;
	hAccelTable = LoadAccelerators(hInst,MAKEINTRESOURCE(IDACCEL));
	if ((hwndMain = Createwinshell4mameWndClassWnd()) == (HWND)0)return 0;
	CreateSBar(hwndMain,GetLangName("7"),5);



	HWND hwSplash=NULL;
	HDIB hDib = DIB_FromResource(hInstance, MAKEINTRESOURCE(IDB_SPLASH));

	if(hDib != NULL){

		hwSplash = Splash_Run(hInstance, NULL, hDib, 0000);
		if (hwSplash == (HWND)NULL){
			MessageBox(NULL, "Splash error!","SPLASHTEST",MB_OK|MB_ICONERROR);
			}


		DIB_Release(hDib);
		}
	Splash_SetTextColor(hwSplash, RGB(128,128,128), FALSE);
	Splash_SetProgressText(hwSplash, GetLangName("8"));

	Create_Menu();


	RECT lpRect;
	GetWindowRect(hWndStatusbar, &lpRect);

	int iWinX=800;
	int iWinY=530;

	if(GetPrivateProfileInt("OPTIONS","Size",0,ini_path)){
		iWinX=GetPrivateProfileInt("OPTIONS","Right",iWinX,ini_path);
		iWinY=GetPrivateProfileInt("OPTIONS","Bottom",iWinY,ini_path);
		}

	int iScrX=((GetSystemMetrics(SM_CXSCREEN)/2)-iWinX/2);
	int iScrY=((GetSystemMetrics(SM_CYSCREEN)/2)-iWinY/2);

	if(GetPrivateProfileInt("OPTIONS","Position",0,ini_path)){
		iScrX=GetPrivateProfileInt("OPTIONS","Left",iScrX,ini_path);
		iScrY=GetPrivateProfileInt("OPTIONS","Top",iScrY,ini_path);
		}

	iSizeWindow=(GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION))-37+((lpRect.bottom-lpRect.top-1)-31);
	SetWindowPos(hwndMain,HWND_BOTTOM,iScrX,iScrY,iWinX,iWinY+iSizeWindow,0);


	OptionsAlwaysOnTop();

	CreateWindows4MAME();

	FillCommandLine();


	int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
	if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
	i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
	if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),1);


	if(GetPrivateProfileInt("OPTIONS","ShowMaximized",0,ini_path))
		ShowWindow(hwndMain,SW_MAXIMIZE);
		else
		ShowWindow(hwndMain,SW_SHOW);


	Fill_Game_Info();



	SetForegroundWindow(hwndMain);
	Splash_Kill(hwSplash);

	if(!ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA)))DialogBox(hInst,"DLGADVICE",hwndMain,(DLGPROC)WT_DLGADVICE);


	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateAccelerator(msg.hwnd,hAccelTable,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

void CreateWindows4MAME(void){

	f_smalltiny=CreateFont(6,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"MS Sans Serif");
	f_smallbold=CreateFont(6,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"MS Sans Serif");

	CreateWindowEx(WS_EX_STATICEDGE,"static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_BITMAP,10,10,773,60,hwndMain,(HMENU)BMP_0,hInst,NULL);
	CreateWindow("static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_BITMAP,11,11,500,58,hwndMain,(HMENU)BMP_1,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,BMP_1),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadBitmap(hInst,MAKEINTRESOURCE(BMP_1)));
	CreateWindow("static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_BITMAP,482,11,100,58,hwndMain,(HMENU)BMP_2,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,BMP_2),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadBitmap(hInst,MAKEINTRESOURCE(BMP_2)));
	CreateWindow("static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_BITMAP,582,11,200,58,hwndMain,(HMENU)BMP_3,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,BMP_3),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadBitmap(hInst,MAKEINTRESOURCE(BMP_3)));

	CreateWindowEx(WS_EX_STATICEDGE,"static",(LPSTR) NULL,WS_VISIBLE|WS_CHILD|SS_BITMAP,567,100,250,200,hwndMain,(HMENU)ID_BMP,hInst,NULL);









	CreateWindow("button",GetLangName("9"),WS_VISIBLE|BS_GROUPBOX|WS_CHILD,554,80,228,324,hwndMain,(HMENU)ID_GROUPMAME,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_GROUPMAME),WM_SETFONT,(WPARAM)f_smallbold,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("13"),BS_GROUPBOX|WS_CHILD,38,123,473,290,hwndMain,(HMENU)ID_GROUPOPT1,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_GROUPOPT1),WM_SETFONT,(WPARAM)f_smallbold,MAKELPARAM(TRUE,0));

	CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_CHILD|ES_AUTOHSCROLL,52,150,444,22,hwndMain,(HMENU)ID_EDIT5,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_EDIT5),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateButtonEx(GetLangName("14"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,426,374,73,28,hwndMain,ID_BUTAPPLY);
	SendMessage(GetDlgItem(hwndMain,ID_BUTAPPLY),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_BUTAPPLY),GetLangName("79"));


	CreateWindow("button",GetLangName("15"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,185,350,22,hwndMain,(HMENU)ID_CHOPT1,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT1),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("16"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,209,350,22,hwndMain,(HMENU)ID_CHOPT2,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT2),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("17"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,233,350,22,hwndMain,(HMENU)ID_CHOPT3,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT3),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("18"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,257,350,22,hwndMain,(HMENU)ID_CHOPT4,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT4),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("19"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,281,350,22,hwndMain,(HMENU)ID_CHOPT5,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT5),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("20"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,305,350,22,hwndMain,(HMENU)ID_CHOPT6,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT6),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("21"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,329,350,22,hwndMain,(HMENU)ID_CHOPT7,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT7),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("22"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,353,350,22,hwndMain,(HMENU)ID_CHOPT8,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT8),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("button",GetLangName("23"),BS_TEXT|BS_AUTOCHECKBOX|WS_CHILD,56,377,350,22,hwndMain,(HMENU)ID_CHOPT9,hInst, NULL);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT9),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow("static","",WS_CHILD|SS_GRAYFRAME,25,115,500,311,hwndMain,(HMENU)ID_GROUPMAME1,hInst,NULL);


	LV_COLUMN lvCT;

	CreateWindowEx(WS_EX_CLIENTEDGE,WC_LISTVIEW,(LPSTR) NULL,LVS_SHOWSELALWAYS|LVS_SINGLESEL|WS_CHILD|LVS_REPORT,25,115,500,311,hwndMain,(HMENU)ID_MAMELV,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_MAMELV), LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		HIMAGELIST hSmall=ImageList_Create(16,16,ILC_COLOR32|TRUE,7,0);

			ImageList_AddIcon(hSmall, LoadIcon (hInst, MAKEINTRESOURCE(ICO_GAMES)));



		ImageList_GetImageCount(hSmall);
		ListView_SetImageList(GetDlgItem(hwndMain,ID_MAMELV), hSmall, LVSIL_SMALL);


		lvCT.mask = LVCF_FMT |LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvCT.fmt  = LVCFMT_LEFT;
		lvCT.cx   = 225;
		lvCT.pszText = GetLangName("24");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 0, &lvCT);
		lvCT.cx   = 50;
		lvCT.pszText = GetLangName("25");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 1, &lvCT);
		lvCT.cx   = 50;
		lvCT.pszText = GetLangName("26");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 2, &lvCT);
		lvCT.cx   = 50;
		lvCT.pszText = GetLangName("27");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 3, &lvCT);
		lvCT.cx   = 50;
		lvCT.pszText = GetLangName("28");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 4, &lvCT);
		lvCT.cx   = 50;
		lvCT.pszText = GetLangName("29");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 5, &lvCT);
		lvCT.cx   = 100;
		lvCT.pszText = GetLangName("30");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 6, &lvCT);
		lvCT.cx   = 100;
		lvCT.pszText = GetLangName("72");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELV), 7, &lvCT);


		lvIT.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVCF_WIDTH;
		lvIT.state = 0;
		lvIT.stateMask = 0;


	Fill_LV_AllGames();

	ListView_SetItemState(GetDlgItem(hwndMain,ID_MAMELV),0,LVNI_FOCUSED|LVNI_SELECTED,LVIF_TEXT|LVIF_IMAGE|LVIF_STATE);
	SetFocus(GetDlgItem(hwndMain,ID_MAMELV));


	LV_COLUMN lvCA;

	CreateWindowEx(WS_EX_CLIENTEDGE,WC_LISTVIEW,(LPSTR) NULL,LVS_SHOWSELALWAYS|WS_VISIBLE|LVS_SINGLESEL|WS_CHILD|LVS_REPORT,25,115,500,311,hwndMain,(HMENU)ID_MAMELVA,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_MAMELVA), LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		HIMAGELIST hSmall0=ImageList_Create(16,16,ILC_COLOR32|TRUE,7,0);

	   		ImageList_AddIcon(hSmall0, LoadIcon (hInst, MAKEINTRESOURCE(ICO_ALLGAMES)));

		ImageList_GetImageCount(hSmall0);
		ListView_SetImageList(GetDlgItem(hwndMain,ID_MAMELVA), hSmall0, LVSIL_SMALL);


		lvCA.mask = LVCF_FMT |LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvCA.fmt  = LVCFMT_LEFT;
		lvCA.cx   = 225;
		lvCA.pszText = GetLangName("24");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 0, &lvCA);
		lvCA.cx   = 50;
		lvCA.pszText = GetLangName("25");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 1, &lvCA);
		lvCA.cx   = 50;
		lvCA.pszText = GetLangName("26");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 2, &lvCA);
		lvCA.cx   = 50;
		lvCA.pszText = GetLangName("27");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 3, &lvCA);
		lvCA.cx   = 50;
		lvCA.pszText = GetLangName("28");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 4, &lvCA);
		lvCA.cx   = 50;
		lvCA.pszText = GetLangName("29");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 5, &lvCA);
		lvCA.cx   = 100;
		lvCA.pszText = GetLangName("30");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 6, &lvCA);
		lvCA.cx   = 100;
		lvCA.pszText = GetLangName("72");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVA), 7, &lvCA);

		lvIA.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVCF_WIDTH;
		lvIA.state = 0;
		lvIA.stateMask = 0;


	LV_COLUMN lvCAA;


	CreateWindowEx(WS_EX_CLIENTEDGE,WC_LISTVIEW,(LPSTR) NULL,LVS_SHOWSELALWAYS|LVS_SINGLESEL|WS_CHILD|LVS_REPORT,25,115,500,311,hwndMain,(HMENU)ID_MAMELVAA,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_MAMELVAA), LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		HIMAGELIST hSmall1=ImageList_Create(16,16,ILC_COLOR32|TRUE,7,0);

	   		ImageList_AddIcon(hSmall1, LoadIcon (hInst, MAKEINTRESOURCE(ICO_EMPTY)));

		ImageList_GetImageCount(hSmall1);
		ListView_SetImageList(GetDlgItem(hwndMain,ID_MAMELVAA), hSmall1, LVSIL_SMALL);


		lvCAA.mask = LVCF_FMT |LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvCAA.fmt  = LVCFMT_LEFT;
		lvCAA.cx   = 150;
		lvCAA.pszText = GetLangName("31");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVAA), 1, &lvCAA);
		lvCAA.cx   = 150;
		lvCAA.pszText = GetLangName("32");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVAA), 2, &lvCAA);
		lvCAA.cx   = 400;
		lvCAA.pszText = GetLangName("33");
		ListView_InsertColumn(GetDlgItem(hwndMain,ID_MAMELVAA), 3, &lvCAA);

		lvIAA.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVCF_WIDTH;
		lvIAA.state = 0;
		lvIAA.stateMask = 0;

	Fill_LV_AvailableGames();

	CreateWindows4_MAME();
	}

void CreateWindows4_MAME(void){

	ListView_SetItemState(GetDlgItem(hwndMain,ID_MAMELVA),0,LVNI_FOCUSED|LVNI_SELECTED,LVIF_TEXT|LVIF_IMAGE|LVIF_STATE);
	SetFocus(GetDlgItem(hwndMain,ID_MAMELVA));


	CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_CHILD|WS_HSCROLL|WS_VSCROLL|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,25,115,500,311,hwndMain,(HMENU)ID_EDIT1,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_EDIT1),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	char win_path[MAX_PATH]="";
	strcpy(win_path,work_path);
	strcat(win_path,"\\docs\\windows.txt");
	Fill_LV_EditBox(win_path,ID_EDIT1,hwndMain);

	CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_CHILD|WS_VSCROLL|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,25,115,500,150,hwndMain,(HMENU)ID_EDIT2,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_EDIT2),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));



	Fill_LV_EditBox(help_path,ID_EDIT2,hwndMain);

	CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_CHILD|WS_VSCROLL|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,25,276,500,150,hwndMain,(HMENU)ID_EDIT3,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_EDIT3),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	strcpy(win_path,work_path);
	strcat(win_path,"\\docs\\mame.txt");
	Fill_LV_EditBox(win_path,ID_EDIT3,hwndMain);


	iGlobLVSort=0;
	hwndLVGlob=GetDlgItem(hwndMain,ID_MAMELV);
	ListView_SortItemsEx(hwndLVGlob, CompareFunc, 1);

	hwndLVGlob=GetDlgItem(hwndMain,ID_MAMELVA);
	ListView_SortItemsEx(hwndLVGlob, CompareFunc, 1);

	hwndLVGlob=GetDlgItem(hwndMain,ID_MAMELVAA);
	ListView_SortItemsEx(hwndLVGlob, CompareFunc, 1);

	UpdateStatusBarLV();



	CreateButtonEx(GetLangName("34"),WS_VISIBLE|BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,553,415,73,28,hwndMain,ID_BUTPLAY);
	SendMessage(GetDlgItem(hwndMain,ID_BUTPLAY),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_BUTPLAY),GetLangName("80"));



	CreateButtonEx(GetLangName("35"),WS_VISIBLE|BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,631,415,73,28,hwndMain,ID_BUTREFRESH);
	SendMessage(GetDlgItem(hwndMain,ID_BUTREFRESH),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_BUTREFRESH),GetLangName("81"));



	CreateButtonEx(GetLangName("36"),WS_VISIBLE|BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,709,415,73,28,hwndMain,ID_BUTDELETE);
	SendMessage(GetDlgItem(hwndMain,ID_BUTDELETE),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_BUTDELETE),GetLangName("82"));



	CreateButtonEx(GetLangName("73"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,553,415,73,28,hwndMain,ID_GETBIOS);
	SendMessage(GetDlgItem(hwndMain,ID_GETBIOS),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_GETBIOS),GetLangName("83"));



	CreateButtonEx(GetLangName("74"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,553,415,73,28,hwndMain,ID_GETGAME);
	SendMessage(GetDlgItem(hwndMain,ID_GETGAME),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_GETGAME),GetLangName("84"));



	CreateButtonEx(GetLangName("75"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,709,415,73,28,hwndMain,ID_GAMELIST);
	SendMessage(GetDlgItem(hwndMain,ID_GAMELIST),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_GAMELIST),GetLangName("85"));



	CreateButtonEx(GetLangName("76"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,553,415,73,28,hwndMain,ID_WEBSITE);
	SendMessage(GetDlgItem(hwndMain,ID_WEBSITE),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_WEBSITE),GetLangName("86"));



	CreateButtonEx(GetLangName("77"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,631,415,73,28,hwndMain,ID_SUPPORT);
	SendMessage(GetDlgItem(hwndMain,ID_SUPPORT),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_SUPPORT),GetLangName("87"));



	CreateButtonEx(GetLangName("78"),BXS_FOCUSRECT|BXS_TABSTOP|BXS_XP,709,415,73,28,hwndMain,ID_ABOUT);
	SendMessage(GetDlgItem(hwndMain,ID_ABOUT),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	Butx_AddToolTipText(GetDlgItem(hwndMain,ID_ABOUT),GetLangName("88"));






	CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",WS_VISIBLE|WS_CHILD|ES_CENTER|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL,567,315,203,76,hwndMain,(HMENU)ID_EDIT4,hInst,NULL);
	SendMessage(GetDlgItem(hwndMain,ID_EDIT4),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));

	CreateWindow(WC_TABCONTROL,(LPSTR) NULL,WS_VISIBLE|WS_TABSTOP|WS_CHILD|WS_CLIPSIBLINGS,10,80,533,363,hwndMain,(HMENU)ID_MAMETAB,hInst,NULL);
		SendMessage(GetDlgItem(hwndMain,ID_MAMETAB),WM_SETFONT,(WPARAM)f_smalltiny,MAKELPARAM(TRUE,0));
	    TC_ITEM tiTUSETAB;
		tiTUSETAB.mask = TCIF_TEXT;
	    tiTUSETAB.pszText = GetLangName("37");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),0,&tiTUSETAB);
	    tiTUSETAB.pszText = GetLangName("38");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),1,&tiTUSETAB);
	    tiTUSETAB.pszText = GetLangName("39");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),2,&tiTUSETAB);
	    tiTUSETAB.pszText = GetLangName("40");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),3,&tiTUSETAB);
	    tiTUSETAB.pszText = GetLangName("41");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),4,&tiTUSETAB);
	    tiTUSETAB.pszText = GetLangName("42");
		TabCtrl_InsertItem(GetDlgItem(hwndMain,ID_MAMETAB),5,&tiTUSETAB);

	}

void Fill_LV_AllGames(void){

	char chTemp[MAX_PATH]="";
	ListView_DeleteAllItems(GetDlgItem(hwndMain,ID_MAMELV));


	FILE *fstream=fopen(gamelist_path,"r");
	if(fstream==NULL)return;


	fseek(fstream,2200,SEEK_SET);

	while(strcmp(chTemp,"+----------------------------------+-------+-------+-------+-------+----------+")!=0){
		fgets( chTemp, 80, fstream );
		}
	fgets( chTemp, 80, fstream );






	int iCheck=0;
	while(!iCheck){

		fgets( chTemp, 80, fstream );

		if(chTemp[0]!='|'){

			iCheck=1;

			}else{

			chTemp[35]='\0';
			chTemp[43]='\0';
			chTemp[51]='\0';
			chTemp[59]='\0';
			chTemp[67]='\0';
			chTemp[78]='\0';

	   		lvIT.iItem = ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELV));
			lvIT.iImage = 0;
			lvIT.iSubItem = 0;
	   		lvIT.pszText = chTemp+2;
			ListView_InsertItem(GetDlgItem(hwndMain,ID_MAMELV), &lvIT);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,1,"0");
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,2,chTemp+36);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,3,chTemp+44);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,4,chTemp+52);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,5,chTemp+60);
			ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),lvIT.iItem,6,chTemp+68);
			}
		fgets( chTemp, 80, fstream );
		}

	fclose( fstream );
	}


void Switch_TAB(void){

	switch(TabCtrl_GetCurSel(GetDlgItem(hwndMain,ID_MAMETAB))){
		case 0:{
			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_SHOW);

			int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
			if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);
			i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
			if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTPLAY),1);
			}break;
		case 1:{
			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_SHOW);

			}break;
		case 2:{
			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_SHOW);

			int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVAA));
			if(!i)EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),0);else EnableWindow(GetDlgItem(hwndMain,ID_BUTDELETE),1);

			}break;
		case 3:{
			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_SHOW);
			}break;
		case 4:{
			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_SHOW);
			}break;
		case 5:{
			ShowWindow(GetDlgItem(hwndMain,ID_BUTPLAY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTREFRESH),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTDELETE),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETBIOS),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GETGAME),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GAMELIST),SW_HIDE);

			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT2),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT3),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT4),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT6),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT7),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT8),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_CHOPT9),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT5),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_BUTAPPLY),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPOPT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_GROUPMAME1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVAA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELVA),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_MAMELV),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT1),SW_HIDE);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT2),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_EDIT3),SW_SHOW);

			ShowWindow(GetDlgItem(hwndMain,ID_ABOUT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_SUPPORT),SW_SHOW);
			ShowWindow(GetDlgItem(hwndMain,ID_WEBSITE),SW_SHOW);

			}break;
		}
	}


char ctmp[15];
char* getstrsize(long long tmp){

	int ed=102;
	char edm;

	if(!tmp)return "0 bytes";
	if(tmp>1073741824){ed=107374182;edm='G';}
	if(tmp<1073741824 && tmp>1048576){ed=104858;edm='M';}
	if(tmp<1048576 && tmp>0){ed=102;edm='K';}

			tmp=(tmp/ed);
			long long prom=(tmp);
			_i64toa( tmp, ctmp, 10 );

			prom=strlen(ctmp);
			if(tmp<10)
				{
					ctmp[2]=ctmp[1];
					ctmp[1]=ctmp[0];
					ctmp[0]='0';
					prom=2;
				}
			ctmp[prom+4]=ctmp[prom];
			ctmp[prom]=ctmp[prom-1];
			ctmp[prom-1]='.';
			ctmp[prom+3]='B';
			ctmp[prom+2]=edm;
			ctmp[prom+1]=' ';

	return ctmp;
	}


void Fill_LV_AvailableGames(void){

	ListView_DeleteAllItems(GetDlgItem(hwndMain,ID_MAMELVA));
	ListView_DeleteAllItems(GetDlgItem(hwndMain,ID_MAMELVAA));

	if(chdir(roms_path)==-1)return;

	WIN32_FIND_DATA fd;
	char full_path[MAX_PATH+1];

 	HANDLE hFind = FindFirstFile("*", &fd);
	if(hFind==INVALID_HANDLE_VALUE)return;

	while(FindNextFile( hFind, &fd )){
		if(strcmp(fd.cFileName,"..")){

			GetFullPathName(fd.cFileName, MAX_PATH, full_path, NULL);
			GetFileTitle(full_path,full_path,MAX_PATH);

			char *p=strrchr(full_path,'.');
			if(p!=NULL)	full_path[(p-full_path)]='\0';

			strlwr(full_path);


			int i=ListView_FindGame(full_path);
			if(i!=-1){

				char chTemp[MAX_PATH]="";

			   	lvIA.iItem = ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
				lvIA.iImage = 0;
				lvIA.iSubItem = 0;

				ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,0,chTemp,MAX_PATH);
			   	lvIA.pszText = chTemp;
				ListView_InsertItem(GetDlgItem(hwndMain,ID_MAMELVA), &lvIA);


				ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,2,chTemp,MAX_PATH);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,2,chTemp);

				ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,3,chTemp,MAX_PATH);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,3,chTemp);

				ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,4,chTemp,MAX_PATH);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,4,chTemp);

				ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,5,chTemp,MAX_PATH);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,5,chTemp);

				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,6,full_path);


				strcpy(chTemp,wini_path);
				strcat(chTemp,full_path);
				strcat(chTemp,".ini");
				GetPrivateProfileString("OPTIONS","Runs","0",full_path,1024,chTemp);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,1,full_path);
				ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,1,full_path);


				GetFullPathName(fd.cFileName, MAX_PATH, chTemp, NULL);
				int fh = _open(chTemp,_O_RDONLY);
					ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVA),lvIA.iItem,7,getstrsize(_filelength(fh)));
					ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,7,getstrsize(_filelength(fh)));
				_close(fh);


				}else{

				   	lvIAA.iItem = ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVAA));
					lvIAA.iImage = 0;
					lvIAA.iSubItem = 0;
				   	lvIAA.pszText = full_path;
					ListView_InsertItem(GetDlgItem(hwndMain,ID_MAMELVAA), &lvIAA);
					GetFullPathName(fd.cFileName, MAX_PATH, full_path, NULL);
					ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVAA),lvIAA.iItem,2,full_path);
					GetFileTitle(full_path,full_path,MAX_PATH);
					ListView_SetItemText(GetDlgItem(hwndMain,ID_MAMELVAA),lvIAA.iItem,1,full_path);
					}
			}
		}

	FindClose(hFind);
	}

int ListView_FindGame(char *full_name){

	int i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELV));
	char chTemp[MAX_PATH]="";

	while(i!=-1){
		ListView_GetItemText(GetDlgItem(hwndMain,ID_MAMELV),i,6,chTemp,MAX_PATH);

		char *p=strchr(chTemp+1,' ');
		if(p!=NULL)chTemp[(p-chTemp)]='\0';

		if(!stricmp(chTemp+1,full_name)){
			return i;
			}
		i--;
		}
	return -1;
	}


void Fill_LV_EditBox(char *ch_path, int i_Item, HWND hWnD){


	int fn = _open(ch_path,_O_RDONLY);
	if(fn==-1)return;

	long ln=_filelength(fn)+10;
	_close(fn);


	FILE *stream=fopen(ch_path,"r");

	char *string = malloc( ln+1000 );

	char ch;
	for(long l=0; l<ln; l++){

		ch=fgetc( stream );

		if(ch=='\n'){
			string[l]='\r';
			string[l+1]='\n';
			l++;
			}else{
				string[l]=ch;
				}
		}

	string[ln-10]='\0';
	SetWindowText(GetDlgItem(hWnD,i_Item),string);

	free( string );
	fclose( stream );
	}

int CheckExistingFile(char *FileName){
	WIN32_FIND_DATA wfd;
	HANDLE fff=FindFirstFile(FileName,&wfd);
	if(fff==INVALID_HANDLE_VALUE)return 0;
	FindClose(fff);
	return 1;
}

void SetGameBmp(char *chGame){


	char chSnap[MAX_PATH]="";
	strcpy(chSnap,work_path);
	strcat(chSnap,"//snap//");
	strcat(chSnap,chGame);
	strcat(chSnap,".png");


	if(!CheckExistingFile(chSnap)){


		CopyFile(defbmp_path,mgbmp_path,FALSE);
		SendMessage(GetDlgItem(hwndMain,ID_BMP),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadImage(hInst,mgbmp_path,IMAGE_BITMAP,202+xRaznica/2,200+yRaznica,LR_LOADFROMFILE));
		return;
		}

	char chFull[MAX_PATH*2+20]="-Q -O ";

	strcat(chFull,mgbmp_path);
	strcat(chFull," ");
	strcat(chFull,chSnap);


	SHELLEXECUTEINFO ShExecInfo = {0};
	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
	ShExecInfo.hwnd = NULL;
	ShExecInfo.lpVerb = NULL;
	ShExecInfo.lpFile = png2bmp_path;
	ShExecInfo.lpParameters = chFull;
	ShExecInfo.lpDirectory = NULL;

	ShExecInfo.hInstApp = NULL;
	ShellExecuteEx(&ShExecInfo);
	WaitForSingleObject(ShExecInfo.hProcess,INFINITE);


	SendMessage(GetDlgItem(hwndMain,ID_BMP),STM_SETIMAGE,IMAGE_BITMAP,(long)LoadImage(hInst,mgbmp_path,IMAGE_BITMAP,202+xRaznica/2,200+yRaznica,LR_LOADFROMFILE));


	strcpy(chFull,mgbmp_path);
	strcat(chFull,".bak");
	DeleteFile(chFull);
	}

void UpdateStatusBarLV(void){

	char win_path[MAX_PATH]="";
	char ch[100]="";
	int i=0;

	i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVA));
	itoa(i,ch,10);
	strcpy(win_path, GetLangName("43"));
	strcat(win_path,ch);
	strcat(win_path,GetLangName("44"));
	UpdateStatusBar(win_path, 1, 0);

	i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELV));
	itoa(i,ch,10);
	strcpy(win_path,GetLangName("45"));
	strcat(win_path,ch);
	strcat(win_path,GetLangName("44"));
	UpdateStatusBar(win_path, 2, 0);

	i=ListView_GetItemCount(GetDlgItem(hwndMain,ID_MAMELVAA));
	itoa(i,ch,10);
	strcpy(win_path,GetLangName("46"));
	strcat(win_path,ch);
	strcat(win_path,GetLangName("47"));
	UpdateStatusBar(win_path, 3, 0);
	}

void Fill_Game_Info(void){

	HWND h=GetDlgItem(hwndMain,ID_MAMELVA);

	switch(TabCtrl_GetCurSel(GetDlgItem(hwndMain,ID_MAMETAB))){
		case 0:{
			h=GetDlgItem(hwndMain,ID_MAMELVA);
			}break;
		case 1:{
			h=GetDlgItem(hwndMain,ID_MAMELV);
			}break;
		}

	if(!ListView_GetItemCount(h))return;

	char t_path[MAX_PATH]="";
	int i=ListView_GetNextItem(h,-1,LVNI_FOCUSED|LVNI_SELECTED);

	if(i<0)i=0;
	int x=ListView_GetItemCount(h)-1;
	if(i>x)i=x;


	char t_path1[MAX_PATH]=" ";
	ListView_GetItemText(h,i,0,t_path,MAX_PATH);
	strcpy(t_path1+1,t_path);


	UpdateStatusBar(t_path1, 0, 0);


	strcpy(t_path1,"\r\n");
	strcat(t_path1,t_path);


	int a=strlen(t_path1)-1;
	while(t_path1[a]==' '){
		a--;
		}
	t_path1[a+1]='\0';


	ListView_GetItemText(h,i,6,t_path,MAX_PATH);


	if(h==GetDlgItem(hwndMain,ID_MAMELV)){
		char ch[MAX_PATH]="";
		strcpy(ch,t_path+1);
		ch[(strchr(ch,' ')-ch)]='\0';
		strcpy(t_path,ch);
		}


	strcat(t_path1,"\r\n\r\n");
	strcat(t_path1,GetLangName("6"));
	strcat(t_path1,t_path);
	SetWindowText(GetDlgItem(hwndMain,ID_EDIT4),t_path1);


	SetGameBmp(t_path);
	}

void FillCommandLine(void){
	char chTemp[1024]="";
	GetPrivateProfileString("OPTIONS","CommandLine","",chTemp,1024,ini_path);
	SetWindowText(GetDlgItem(hwndMain,ID_EDIT5),chTemp);

	SendMessage(GetDlgItem(hwndMain,ID_CHOPT1),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_1",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT2),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_2",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT3),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_3",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT4),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_4",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT5),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_5",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT6),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_6",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT7),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_7",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT8),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_8",0,ini_path),0);
	SendMessage(GetDlgItem(hwndMain,ID_CHOPT9),BM_SETCHECK,GetPrivateProfileInt("OPTIONS","Option_9",0,ini_path),0);
	}

void ApplyCommandLine(void){

	char chTempLang1[MAX_PATH];strcpy(chTempLang1,GetLangName("4"));
	char chTempLang2[MAX_PATH];strcpy(chTempLang2,GetLangName("48"));
	if(IDYES!=MessageBox(hwndMain,chTempLang2,chTempLang1,MB_YESNO|MB_ICONQUESTION))return;

	char chTemp[1024]="";
	GetWindowText(GetDlgItem(hwndMain,ID_EDIT5),chTemp,1024);
	WritePrivateProfileString("OPTIONS","CommandLine",chTemp,ini_path);

	WritePrivateProfileInt("OPTIONS", "Option_1", SendMessage(GetDlgItem(hwndMain,ID_CHOPT1),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_2", SendMessage(GetDlgItem(hwndMain,ID_CHOPT2),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_3", SendMessage(GetDlgItem(hwndMain,ID_CHOPT3),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_4", SendMessage(GetDlgItem(hwndMain,ID_CHOPT4),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_5", SendMessage(GetDlgItem(hwndMain,ID_CHOPT5),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_6", SendMessage(GetDlgItem(hwndMain,ID_CHOPT6),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_7", SendMessage(GetDlgItem(hwndMain,ID_CHOPT7),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_8", SendMessage(GetDlgItem(hwndMain,ID_CHOPT8),BM_GETCHECK,0,0), ini_path);
	WritePrivateProfileInt("OPTIONS", "Option_9", SendMessage(GetDlgItem(hwndMain,ID_CHOPT9),BM_GETCHECK,0,0), ini_path);

	strcpy(chTempLang2,GetLangName("49"));
	MessageBox(hwndMain,chTempLang2,chTempLang1,MB_OK|MB_ICONEXCLAMATION);
	}

void AddCommandLineOptions(char *t_path){

	if(GetPrivateProfileInt("OPTIONS","Option_1",0,ini_path))strcat(t_path," -nosound");
	if(GetPrivateProfileInt("OPTIONS","Option_2",0,ini_path))strcat(t_path," -window");
	if(GetPrivateProfileInt("OPTIONS","Option_3",0,ini_path))strcat(t_path," -mouse");
	if(GetPrivateProfileInt("OPTIONS","Option_4",0,ini_path))strcat(t_path," -skip_disclaimer");
	if(GetPrivateProfileInt("OPTIONS","Option_5",0,ini_path))strcat(t_path," -skip_gameinfo");
	if(GetPrivateProfileInt("OPTIONS","Option_6",0,ini_path))strcat(t_path," -high_priority");
	if(GetPrivateProfileInt("OPTIONS","Option_7",0,ini_path))strcat(t_path," -sl");
	if(GetPrivateProfileInt("OPTIONS","Option_8",0,ini_path))strcat(t_path," -matchrefresh");
	if(GetPrivateProfileInt("OPTIONS","Option_9",0,ini_path))strcat(t_path," -triplebuffer");

	char chTemp[1024]="";
	GetPrivateProfileString("OPTIONS","CommandLine","",chTemp,1024,ini_path);
	if(chTemp[0]!='\0'){
		strcat(t_path," ");
		strcat(t_path,chTemp);
		}
	}

void Create_Menu(void){

	hvMenu = CreateMenu();
	HMENU hSubMenu = CreatePopupMenu();

	AppendMenu(hvMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, GetLangName("50"));
	AppendMenu(hSubMenu, MF_STRING, ID_NEW_MENU, GetLangName("51"));
	AppendMenu(hSubMenu, MF_STRING, ID_OPEN_MENU, GetLangName("52"));
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	AppendMenu(hSubMenu, MF_STRING, IDM_EXIT, GetLangName("53"));

	hSubMenu = CreatePopupMenu();
	AppendMenu(hvMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, GetLangName("54"));
	AppendMenu(hSubMenu, MF_STRING, ID_BUTPLAY, GetLangName("55"));
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	AppendMenu(hSubMenu, MF_STRING, ID_BUTREFRESH, GetLangName("56"));
	AppendMenu(hSubMenu, MF_STRING, ID_BUTDELETE, GetLangName("57"));
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	AppendMenu(hSubMenu, MF_STRING, ID_COMMAND, GetLangName("58"));

	hSubMenu = CreatePopupMenu();
	AppendMenu(hvMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, GetLangName("59"));
	AppendMenu(hSubMenu, MF_STRING, ID_LANG_MENU, "Lan&guage");
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	int iKey=GetPrivateProfileInt("OPTIONS","Ontop",0,ini_path)?MF_CHECKED:MF_UNCHECKED;
	AppendMenu(hSubMenu, MF_STRING|iKey, ID_ONTOP_MENU, GetLangName("61"));
	iKey=GetPrivateProfileInt("OPTIONS","Magnet",0,ini_path)?MF_CHECKED:MF_UNCHECKED;
	AppendMenu(hSubMenu, MF_STRING|iKey, ID_MAGNET_MENU, GetLangName("62"));
	iKey=GetPrivateProfileInt("OPTIONS","Size",0,ini_path)?MF_CHECKED:MF_UNCHECKED;
	AppendMenu(hSubMenu, MF_STRING|iKey, ID_SIZE_MENU, GetLangName("63"));
	iKey=GetPrivateProfileInt("OPTIONS","Position",0,ini_path)?MF_CHECKED:MF_UNCHECKED;
	AppendMenu(hSubMenu, MF_STRING|iKey, ID_POSITION_MENU, GetLangName("64"));

	hSubMenu = CreatePopupMenu();
	AppendMenu(hvMenu, MF_STRING | MF_POPUP | MF_HELP, (UINT)hSubMenu, GetLangName("65"));
	AppendMenu(hSubMenu, MF_STRING, IDM_HELP, GetLangName("66"));
	AppendMenu(hSubMenu, MF_STRING, IDM_LICENSE, GetLangName("67"));
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	AppendMenu(hSubMenu, MF_STRING, IDM_WEB, GetLangName("68"));
	AppendMenu(hSubMenu, MF_STRING, IDM_EMAIL, GetLangName("69"));
	AppendMenu(hSubMenu, MF_STRING, IDM_DOWNLOAD, GetLangName("70"));
	AppendMenu(hSubMenu, MF_SEPARATOR, 0, "");
	AppendMenu(hSubMenu, MF_STRING, IDM_ABOUT, GetLangName("71"));

	SetMenu(hwndMain, hvMenu);

	HMENU hsub = GetSubMenu(hvMenu, 0);
	CoolMenu_Create(hsub, "File");
	hsub = GetSubMenu(hvMenu, 1);
	CoolMenu_Create(hsub, "Action");
	hsub = GetSubMenu(hvMenu, 2);
	CoolMenu_Create(hsub, "Options");
	hsub = GetSubMenu(hvMenu, 3);
	CoolMenu_Create(hsub, "Help");

	}

void Switch_List(void){

		char t_path[MAX_PATH]="";
		char t_path1[MAX_PATH]=" ";
		HWND h=GetDlgItem(hwndMain,ID_MAMELVA);
		switch(TabCtrl_GetCurSel(GetDlgItem(hwndMain,ID_MAMETAB))){
			case 0:{
				h=GetDlgItem(hwndMain,ID_MAMELVA);
				}break;
			case 1:{
				h=GetDlgItem(hwndMain,ID_MAMELV);
				}break;
			}

		int i=ListView_GetNextItem(h,-1,LVNI_FOCUSED|LVNI_SELECTED);
		ListView_GetItemText(h,i,0,t_path,MAX_PATH);

		strcpy(t_path1+1,t_path);

		UpdateStatusBar(t_path1, 0, 0);

	}





LRESULT CALLBACK WT_DLGADVICE(HWND hwndADVICE,UINT uMsg,WPARAM wParam,LPARAM lParam){
	switch(uMsg){
		case WM_INITDIALOG :{




			Fill_LV_EditBox(help_path,ID_ADVTXT,hwndADVICE);



			SetWindowText(GetDlgItem(hwndADVICE,ID_MOREINFO),GetLangName("1279"));

			}break;

		case WM_COMMAND :
            switch(LOWORD(wParam)){

				case IDOK:{
					EndDialog(hwndADVICE,IDOK);
					}break;

				case IDCANCEL:
					EndDialog(hwndADVICE,IDCANCEL);
					break;

            	}break;
		default: return FALSE;
		}

	return TRUE;
	}

